/***
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    Project: www.simpledbm.org
 *    Author : Dibyendu Majumdar
 *    Email  : dibyendu@mazumdar.demon.co.uk
 */
/*
 * Created on: 06-Dec-2005
 * Author: Dibyendu Majumdar
 */
package org.simpledbm.samples.transaction;

import org.simpledbm.rss.tm.Transaction;
import org.simpledbm.rss.tm.TrxMgr;

public class Main {

    public static boolean doCreate() {
        OneBitMgrDatabase db = new OneBitMgrDatabase();
        try {
            db.create();
            db.open();
            OneBitMgr bitmgr = db.getOneBitMgr();
            bitmgr.create("testbit.dat", 1);
        } catch (Exception e) {
            e.printStackTrace();
            return false;
        }
        finally {
            db.shutdown();
        }
        return true;
    }
    
    /**
     * @param args
     */
    public static void main(String[] args) {
        if (args.length > 0 && args[0].equalsIgnoreCase("-create")) {
            if (!doCreate()) {
                System.exit(1);
            }
            return;
        }
        OneBitMgrDatabase db = new OneBitMgrDatabase();
        try {
            db.open();
            OneBitMgr bitmgr = db.getOneBitMgr();

            TrxMgr trxmgr = db.getTrxmgr();
            Transaction trx = trxmgr.begin();
            boolean success = false;
            try {
                bitmgr.changeBit(1, trx, 1, 1);
                success = true;
            }
            finally {
                if (success)
                    trx.commit();
                else
                    trx.abort();
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            db.shutdown();
        }
    }
}
