/***
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    Project: www.simpledbm.org
 *    Author : Dibyendu Majumdar
 *    Email  : dibyendu@mazumdar.demon.co.uk
 */
package org.simpledbm.rss.tm;

import org.simpledbm.rss.pm.PageId;

/**
 * Extends the standard Redoable interface to allow the Log Operation to cover
 * multiple pages. At present only Redoable and Compensation records can use this
 * interface.  
 */
public interface MultiPageRedo extends Redoable {
	
	/**
	 * Should return the IDs of the pages that will be affected by the log record.
	 * Must include the default page return by {@link Loggable#getPageId()}.
	 */
	public PageId[] getPageIds();
}
